package org.drools.examples;

import java.io.InputStreamReader;

import org.drools.RuleBase;
import org.drools.RuleBaseFactory;
import org.drools.StatefulSession;
import org.drools.compiler.PackageBuilder;

public class BilboAndTheDwarfs {

    /**
     * @param args
     */
    public static void main(final String[] args) throws Exception {

        final PackageBuilder builder = new PackageBuilder();
        builder.addPackageFromDrl( new InputStreamReader( BilboAndTheDwarfs.class.getResourceAsStream( "BilboAndTheDwarfs.drl" ) ) );

        final RuleBase ruleBase = RuleBaseFactory.newRuleBase();
        ruleBase.addPackage( builder.getPackage() );

        final StatefulSession session = ruleBase.newStatefulSession();
        
        System.out.println("Init:");
        int[]	 pos	= new int[]			{  1,       2,       3,        4,        5,      6,      7,       8,       9     };
        String[] name 	= new String[]		{ "Bilbo", "Balin", "Bombur", "Dwalin", "Fili", "Kili", "Gloin", "Nori",  "Ori"  };
        
        for ( int n = 0; n < pos.length; n++ ) {
            for ( int f = 0; f < name.length; f++ ) {
                				System.out.println("pn:"+n+"-"+f+": "+pos[n] +" - "+  name[f]);
                				session.insert( new Dwarf( pos[n],  name[f]));
            }
        }

        System.out.println("fireAllRules()");
        session.fireAllRules();
        System.out.println("dispose()");
        session.dispose();
        System.out.println("done.");
    }


    public static class Dwarf {
    	private int pos;
    	private String name;
        
        public Dwarf() {
        	
        }
        
        public Dwarf(int pos, String name) {
            super();
            this.pos = pos;
            this.name = name;
        }

		public int getPos() {
			return pos;
		}

		public String getName() {
			return name;
		}

    }
}

